BEGIN {
  if (mode != "check") {
    if (mode != "change") {
      print "First.awk: mode is not correct";
      print "it should be \"check\" or \"change\"";
      exit;
    }
  }

  testIt ="no";
  #testIt ="yes";

  previousLine = "";
  firstLineIsEmpty = "yes";
} # end of BEGIN

{ # do the job
  theLine = $0;
  if (testIt == "yes") {
    printf("(20)\n");
    printf("(21) %d: theLine >%s<\n", NR, theLine);
  }
  # look for empty(ies) first line(s)
  if (firstLineIsEmpty == "yes") {
    lengthOfTheLine = length(theLine);
    if (testIt == "yes") {
      printf("(27) %d: lengthOfTheLine=%d\n", NR, lengthOfTheLine);
    }
    if (lengthOfTheLine == 0) {
      if (mode == "check") {
        if (testIt == "yes") {
          printf( "(32) %d: ", NR);
        }
        printf( "The first line is empty\n");
      }
    } else {
      if (testIt == "yes") {
        printf( "(38) %d: firstLineIsEmpty set to no\n", NR);
      }
      firstLineIsEmpty = "no";
      previousLine = theLine;
    }
  } else {
    if (mode == "change") {
      if (testIt == "yes") {
        printf("(46) %d: previousLine >%s<\n", NR - 1, previousLine);
      }
      printf("%s\n", previousLine);
    }
    previousLine = theLine;
  }
}
END {
  # for the last line
  lengthOfTheLine = length(theLine);
  if (testIt == "yes") {
    printf("(57) %d: last line: lengthOfTheLine=%d\n", NR, lengthOfTheLine);
  }
  if (lengthOfTheLine == 0) {
    if (mode == "check") {
      if (testIt == "yes") {
        printf("(62) %d: ", NR);
      }
      printf("The last line is empty\n");
    }
  } else {
    if (mode == "change") {
      if (testIt == "yes") {
        printf("(69) %d: the line before the last line >%s<\n", NR - 1, previousLine);
      }
      printf("%s\n", theLine);
    }
  }
}
