#!/bin/bash
#
# Copyright 2014 by guy maurel
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License along
# with this program; if not, write to the Free Software Foundation, Inc.,
# 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301, USA.
#
# 12 january   2014
# 26 september 2014
#
# where you have store the script and the awk-program
DIR=./
#
numberOfParameter=$#
if [ ${numberOfParameter} -ne 4 ] ;
then
  echo "Parameter is missing"
  echo "${numberOfParameter} Parameter(s) present"
  exit
fi
#
KEYWORD=${1}
THENEXT=${2}
MODE=${3}
WHERE=${4}
#
if [ ${THENEXT} == "star" ] ;
then
  gawk -f ${DIR}/SpaceAfter.awk \
    --assign keyword="${KEYWORD}" --assign theNext="*" --assign mode="${MODE}" \
    ${WHERE} > coding-style-Space.tmp
else
  gawk -f ${DIR}/SpaceAfter.awk \
    --assign keyword="${KEYWORD}" --assign theNext="${THENEXT}" --assign mode="${MODE}" \
    ${WHERE} > coding-style-Space.tmp
fi
#
if [ ${MODE} == "check" ] ;
then
  if [ -s coding-style-Space.tmp ] ;
  then
    echo "check the file "`pwd`/${WHERE}
    cat coding-style-Space.tmp
    echo ""
    rm coding-style-Space.tmp
  fi
else
  # change
  if [ -s coding-style-Space.tmp ] ;
  then
    mv coding-style-Space.tmp ${WHERE}
  fi
fi
